GNU bug report logs - #13780
24.2; Making find-file-hook customizable seems to cause troublle

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Severity: minor; Reported by: Reuben Thomas <rrt@HIDDEN>; dated Fri, 22 Feb 2013 00:36:01 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 13780 <at> debbugs.gnu.org:


Received: (at 13780) by debbugs.gnu.org; 22 Feb 2013 20:59:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 22 15:59:40 2013
Received: from localhost ([127.0.0.1]:44713 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U8ziV-0000Qf-Rx
	for submit <at> debbugs.gnu.org; Fri, 22 Feb 2013 15:59:40 -0500
Received: from ironport2-out.teksavvy.com ([206.248.154.182]:28532)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1U8ziU-0000QZ-Bf
	for 13780 <at> debbugs.gnu.org; Fri, 22 Feb 2013 15:59:38 -0500
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: AhAKABK/CFFsoXXp/2dsb2JhbABEvgwEA3sXc4IeAQEEAVYjEAsOJhIUGA0kiB4GwS2RCgOIYZwZgV6DFQ
X-IPAS-Result: AhAKABK/CFFsoXXp/2dsb2JhbABEvgwEA3sXc4IeAQEEAVYjEAsOJhIUGA0kiB4GwS2RCgOIYZwZgV6DFQ
X-IronPort-AV: E=Sophos;i="4.84,565,1355115600"; 
   d="scan'208";a="2000477"
Received: from 108-161-117-233.dsl.teksavvy.com (HELO pastel.home)
	([108.161.117.233])
	by ironport2-out.teksavvy.com with ESMTP/TLS/ADH-AES256-SHA;
	22 Feb 2013 15:58:12 -0500
Received: by pastel.home (Postfix, from userid 20848)
	id 3E5016CB02; Fri, 22 Feb 2013 15:58:13 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Reuben Thomas <rrt@HIDDEN>
Subject: Re: bug#13780: 24.2;
	Making find-file-hook customizable seems to cause troublle
Message-ID: <jwv7gm0vzfn.fsf-monnier+emacs@HIDDEN>
References: <87k3q1gpba.fsf@HIDDEN> <jwvvc9lyu61.fsf-monnier+emacs@HIDDEN>
	<CAOnWdoisCVSF75=6ni7BHXiXqrhB5nAOU28tF5gkggZUsfWBtQ@HIDDEN>
	<jwv38wozazs.fsf-monnier+emacs@HIDDEN>
	<CAOnWdoiCmKU9KPFQN2M_c0RH+PG4kq6OYeVGOhTs3RNSfhOiYg@HIDDEN>
Date: Fri, 22 Feb 2013 15:58:13 -0500
In-Reply-To: <CAOnWdoiCmKU9KPFQN2M_c0RH+PG4kq6OYeVGOhTs3RNSfhOiYg@HIDDEN>
	(Reuben Thomas's message of "Fri, 22 Feb 2013 19:38:06 +0000")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -1.9 (-)
X-Debbugs-Envelope-To: 13780
Cc: 13780 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

>> So until Custom ...blabla... I think it's better to use defcustom for
>> hooks very sparingly, i.e. only for those hook we can reasonably
>> expect will only be modified by the user's customization.
> So do you think the existing customization ability for find-file-hook
> should be removed? Or at least some kind of warning attached?

Yes,


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13780; Package emacs. Full text available.

Message received at 13780 <at> debbugs.gnu.org:


Received: (at 13780) by debbugs.gnu.org; 22 Feb 2013 19:39:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 22 14:39:39 2013
Received: from localhost ([127.0.0.1]:44680 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U8yT3-0006zp-Kv
	for submit <at> debbugs.gnu.org; Fri, 22 Feb 2013 14:39:38 -0500
Received: from exprod7og123.obsmtp.com ([64.18.2.24]:34968)
	by debbugs.gnu.org with smtp (Exim 4.72)
	(envelope-from <rrt@HIDDEN>) id 1U8ySx-0006ze-Th
	for 13780 <at> debbugs.gnu.org; Fri, 22 Feb 2013 14:39:34 -0500
Received: from mail-lb0-f199.google.com ([209.85.217.199]) (using TLSv1) by
	exprod7ob123.postini.com ([64.18.6.12]) with SMTP
	ID DSNKUSfJHiMuPqPIzfUmfneh/HJaJIsMMUmO@HIDDEN;
	Fri, 22 Feb 2013 11:38:08 PST
Received: by mail-lb0-f199.google.com with SMTP id m4so1445298lbo.2
	for <13780 <at> debbugs.gnu.org>; Fri, 22 Feb 2013 11:38:06 -0800 (PST)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
	d=google.com; s=20120113;
	h=x-received:mime-version:x-received:in-reply-to:references:date
	:message-id:subject:from:to:cc:content-type:x-gm-message-state;
	bh=7MJPbTWaarITY0XO1p4aj8TaWj/wKAFlthYLlES4Guc=;
	b=Pl4yuctkhdqnK7eMpSDIiQsqS5DxPJIs1KyiJBYTNLagltjobbY/tblM59CNJOeByZ
	bKZ8jlZ6ipPCKHor2KafNJ0ibss2nrxxDTd9XeSAHLZ8A5Dvd2qqp289Ny5RKphqblm6
	y/YzLVHQdrdcDiMLXGwTEY/KsNdtQq4LpSVudzZ/6NM/HD5g9+M8oymERfFYXzqwP74S
	sCpCkCMEda5eS2XI0rS7JF5O8AKa4GaYfeG2+dWJVm4iVWGQlNeZHOWXFGA+FTtRU/hO
	HOi/1WYfsQaY7k9Ood9M4xj9zEi8TLckP1mhUSBBHi02WS3BCZZPCF3B7X8zCE/Bymqb
	pAGg==
X-Received: by 10.152.130.131 with SMTP id oe3mr2787948lab.1.1361561886291;
	Fri, 22 Feb 2013 11:38:06 -0800 (PST)
MIME-Version: 1.0
X-Received: by 10.152.130.131 with SMTP id oe3mr2787939lab.1.1361561886121;
	Fri, 22 Feb 2013 11:38:06 -0800 (PST)
Received: by 10.152.5.40 with HTTP; Fri, 22 Feb 2013 11:38:06 -0800 (PST)
In-Reply-To: <jwv38wozazs.fsf-monnier+emacs@HIDDEN>
References: <87k3q1gpba.fsf@HIDDEN> <jwvvc9lyu61.fsf-monnier+emacs@HIDDEN>
	<CAOnWdoisCVSF75=6ni7BHXiXqrhB5nAOU28tF5gkggZUsfWBtQ@HIDDEN>
	<jwv38wozazs.fsf-monnier+emacs@HIDDEN>
Date: Fri, 22 Feb 2013 19:38:06 +0000
Message-ID: <CAOnWdoiCmKU9KPFQN2M_c0RH+PG4kq6OYeVGOhTs3RNSfhOiYg@HIDDEN>
Subject: Re: bug#13780: 24.2; Making find-file-hook customizable seems to
	cause troublle
From: Reuben Thomas <rrt@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Content-Type: text/plain; charset=ISO-8859-1
X-Gm-Message-State: ALoCoQkHJl9tUu9PYbB+23w+tcDVOCdoHvSDIuu9T7oG18cA5ynIjVDBk8szF4CflLIAycablDBPTAspQc3uTfneQV+hhxNcC4emfccPTXwZ1UztXGu3nd5/xd31+jhM8F7szgepiO0hUU3uZ7nk/Gq0tbqUbwwFNfFwl1uFeav38lYGJi39ukc=
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 13780
Cc: 13780 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -4.2 (----)

On 22 February 2013 14:22, Stefan Monnier <monnier@HIDDEN> wrote:
>
>    So until Custom ...blabla... I think it's better to use defcustom for
>    hooks very sparingly, i.e. only for those hook we can reasonably
>    expect will only be modified by the user's customization.

So do you think the existing customization ability for find-file-hook
should be removed? Or at least some kind of warning attached?

--
http://rrt.sc3d.org




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13780; Package emacs. Full text available.

Message received at 13780 <at> debbugs.gnu.org:


Received: (at 13780) by debbugs.gnu.org; 22 Feb 2013 14:23:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 22 09:23:46 2013
Received: from localhost ([127.0.0.1]:43953 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U8tXN-000611-QU
	for submit <at> debbugs.gnu.org; Fri, 22 Feb 2013 09:23:46 -0500
Received: from ironport2-out.teksavvy.com ([206.248.154.182]:49168)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1U8tXL-00060s-SL
	for 13780 <at> debbugs.gnu.org; Fri, 22 Feb 2013 09:23:44 -0500
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: Av8EABK/CFFsoXXp/2dsb2JhbABEhke4Rxdzgh4BAQQBIzMjEAsODAIYDgICFBgNJIgeBq5fkk6BI45UgRMDiGGcGYFegxU
X-IPAS-Result: Av8EABK/CFFsoXXp/2dsb2JhbABEhke4Rxdzgh4BAQQBIzMjEAsODAIYDgICFBgNJIgeBq5fkk6BI45UgRMDiGGcGYFegxU
X-IronPort-AV: E=Sophos;i="4.84,565,1355115600"; 
   d="scan'208";a="1965560"
Received: from 108-161-117-233.dsl.teksavvy.com (HELO pastel.home)
	([108.161.117.233])
	by ironport2-out.teksavvy.com with ESMTP/TLS/ADH-AES256-SHA;
	22 Feb 2013 09:22:20 -0500
Received: by pastel.home (Postfix, from userid 20848)
	id 9B1FF6BF3C; Fri, 22 Feb 2013 09:22:20 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Reuben Thomas <rrt@HIDDEN>
Subject: Re: bug#13780: 24.2;
	Making find-file-hook customizable seems to cause troublle
Message-ID: <jwv38wozazs.fsf-monnier+emacs@HIDDEN>
References: <87k3q1gpba.fsf@HIDDEN> <jwvvc9lyu61.fsf-monnier+emacs@HIDDEN>
	<CAOnWdoisCVSF75=6ni7BHXiXqrhB5nAOU28tF5gkggZUsfWBtQ@HIDDEN>
Date: Fri, 22 Feb 2013 09:22:20 -0500
In-Reply-To: <CAOnWdoisCVSF75=6ni7BHXiXqrhB5nAOU28tF5gkggZUsfWBtQ@HIDDEN>
	(Reuben Thomas's message of "Fri, 22 Feb 2013 11:43:01 +0000")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 13780
Cc: 13780 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

>> So until Custom is fixed to actually properly handle customisation of
>> hooks (e.g. by storing "add functions foo, bar, and baz" rather than
>> "ignore current value and just set it to (foo bar baz)").
> This sentence seems to be missing its main clause=E2=80=A6

That's not just an appearance.  Its main clause is:

   So until Custom ...blabla... I think it's better to use defcustom for
   hooks very sparingly, i.e. only for those hook we can reasonably
   expect will only be modified by the user's customization.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13780; Package emacs. Full text available.

Message received at 13780 <at> debbugs.gnu.org:


Received: (at 13780) by debbugs.gnu.org; 22 Feb 2013 11:44:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 22 06:44:29 2013
Received: from localhost ([127.0.0.1]:43839 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U8r3E-0001Sh-O7
	for submit <at> debbugs.gnu.org; Fri, 22 Feb 2013 06:44:28 -0500
Received: from exprod7og107.obsmtp.com ([64.18.2.167]:39793)
	by debbugs.gnu.org with smtp (Exim 4.72)
	(envelope-from <rrt@HIDDEN>) id 1U8r3B-0001SX-5v
	for 13780 <at> debbugs.gnu.org; Fri, 22 Feb 2013 06:44:26 -0500
Received: from mail-we0-f197.google.com ([74.125.82.197]) (using TLSv1) by
	exprod7ob107.postini.com ([64.18.6.12]) with SMTP
	ID DSNKUSdZxVs957bGVP4Emn2CczP5n1wL0oUO@HIDDEN;
	Fri, 22 Feb 2013 03:43:03 PST
Received: by mail-we0-f197.google.com with SMTP id t44so743699wey.4
	for <13780 <at> debbugs.gnu.org>; Fri, 22 Feb 2013 03:43:01 -0800 (PST)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
	d=google.com; s=20120113;
	h=x-received:mime-version:x-received:in-reply-to:references:date
	:message-id:subject:from:to:cc:content-type
	:content-transfer-encoding:x-gm-message-state;
	bh=Sf8DFQj5VO9iz5cZ7teI5lMLIIlJCPnGgLIi2eamCdY=;
	b=aquqnbpyzW/XSPDLLyyzNEPYym6GllxGp/KK/Up9lm2kCkw/GjE43HNGJGsVqn1/15
	e3CCV6LnXcW7bOScxUQcgRpVrWU5EUmBPATUJw/EaiS+LQQKyvUusIO4eIpbJc2kkWYn
	TU4yMO/8SOOrU11TsPLP5k2W/Z+hcT7Xx8XZ5z9Aomzh4+jmiE1lVR3c57pQmjOyJEE+
	qFtYyEsNsvkS6FPPv/9vyZrIPiS+y0Symb3n0vsL/hIxv1ZGtpyV+DLpfwdzSF1U48IW
	aLCQ5OdIp9oa6P3SRHmrz9iDvQts7U7skScwyIsyjLhvhX1SnjqF2l0v4KIRmpGWD9Vi
	J6rw==
X-Received: by 10.112.13.162 with SMTP id i2mr825257lbc.105.1361533381489;
	Fri, 22 Feb 2013 03:43:01 -0800 (PST)
MIME-Version: 1.0
X-Received: by 10.112.13.162 with SMTP id i2mr825254lbc.105.1361533381350;
	Fri, 22 Feb 2013 03:43:01 -0800 (PST)
Received: by 10.152.5.40 with HTTP; Fri, 22 Feb 2013 03:43:01 -0800 (PST)
In-Reply-To: <jwvvc9lyu61.fsf-monnier+emacs@HIDDEN>
References: <87k3q1gpba.fsf@HIDDEN> <jwvvc9lyu61.fsf-monnier+emacs@HIDDEN>
Date: Fri, 22 Feb 2013 11:43:01 +0000
Message-ID: <CAOnWdoisCVSF75=6ni7BHXiXqrhB5nAOU28tF5gkggZUsfWBtQ@HIDDEN>
Subject: Re: bug#13780: 24.2; Making find-file-hook customizable seems to
	cause troublle
From: Reuben Thomas <rrt@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Content-Type: text/plain; charset=windows-1252
Content-Transfer-Encoding: quoted-printable
X-Gm-Message-State: ALoCoQkks743OY/rIhVyEiFAydFyV0tjF8FdQUqx2Rr+mJivHDGMSzKSemsoR6ssdzTxEQUqTeQM8aVf9LxPrvnmdROgYDffYV34Nx/lDq5nKhbmEmHgaH7djts3jww9zYe8QDH+Rtu/2rLANPQ6P1fXUZY5eg4y+L8I/Nc3ChWuuPve2F4sDns=
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 13780
Cc: 13780 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -4.2 (----)

On 22 February 2013 02:14, Stefan Monnier <monnier@HIDDEN> wrote:
>
> So until Custom is fixed to actually properly handle customisation of
> hooks (e.g. by storing "add functions foo, bar, and baz" rather than
> "ignore current value and just set it to (foo bar baz)").

This sentence seems to be missing its main clause=85

--=20
http://rrt.sc3d.org




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13780; Package emacs. Full text available.

Message received at 13780 <at> debbugs.gnu.org:


Received: (at 13780) by debbugs.gnu.org; 22 Feb 2013 02:16:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 21 21:16:20 2013
Received: from localhost ([127.0.0.1]:43405 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U8iBQ-0004Xn-9s
	for submit <at> debbugs.gnu.org; Thu, 21 Feb 2013 21:16:20 -0500
Received: from ironport2-out.teksavvy.com ([206.248.154.182]:17695)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1U8iBN-0004Xf-8W
	for 13780 <at> debbugs.gnu.org; Thu, 21 Feb 2013 21:16:17 -0500
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: Av4EABK/CFFsoXXp/2dsb2JhbABEvw4Xc4IeAQEEAVYjBQsLDiYSFBgNJIgeBsEtkQoDiGGcGYFegxU
X-IPAS-Result: Av4EABK/CFFsoXXp/2dsb2JhbABEvw4Xc4IeAQEEAVYjBQsLDiYSFBgNJIgeBsEtkQoDiGGcGYFegxU
X-IronPort-AV: E=Sophos;i="4.84,565,1355115600"; 
   d="scan'208";a="1940770"
Received: from 108-161-117-233.dsl.teksavvy.com (HELO pastel.home)
	([108.161.117.233])
	by ironport2-out.teksavvy.com with ESMTP/TLS/ADH-AES256-SHA;
	21 Feb 2013 21:14:56 -0500
Received: by pastel.home (Postfix, from userid 20848)
	id 9CCB16BF0E; Thu, 21 Feb 2013 21:14:56 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Reuben Thomas <rrt@HIDDEN>
Subject: Re: bug#13780: 24.2;
	Making find-file-hook customizable seems to cause troublle
Message-ID: <jwvvc9lyu61.fsf-monnier+emacs@HIDDEN>
References: <87k3q1gpba.fsf@HIDDEN>
Date: Thu, 21 Feb 2013 21:14:56 -0500
In-Reply-To: <87k3q1gpba.fsf@HIDDEN> (Reuben Thomas's message of "Fri, 22
	Feb 2013 00:33:29 +0000")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 13780
Cc: 13780 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

> The real problem here is that find-file-hook is clearly meant to be
> customizable (there is even a check box for auto-indent in its

But Custom only properly handles hooks which is only sets via Custom,
whereas it's reasonably common for find-file-hook to be modified by
packages (via add-hook, of course).
So until Custom is fixed to actually properly handle customisation of
hooks (e.g. by storing "add functions foo, bar, and baz" rather than
"ignore current value and just set it to (foo bar baz)").


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13780; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 22 Feb 2013 00:35:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 21 19:35:29 2013
Received: from localhost ([127.0.0.1]:43163 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1U8gbo-0000Gu-5Q
	for submit <at> debbugs.gnu.org; Thu, 21 Feb 2013 19:35:29 -0500
Received: from eggs.gnu.org ([208.118.235.92]:59939)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <rrt@HIDDEN>) id 1U8gbl-0000Gn-FW
	for submit <at> debbugs.gnu.org; Thu, 21 Feb 2013 19:35:27 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <rrt@HIDDEN>) id 1U8gaJ-00011Y-8A
	for submit <at> debbugs.gnu.org; Thu, 21 Feb 2013 19:34:05 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-104.2 required=5.0 tests=BAYES_00, RCVD_IN_DNSWL_MED,
	T_FRT_FRIEND,USER_IN_WHITELIST autolearn=unavailable version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:44310)
	by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <rrt@HIDDEN>)
	id 1U8gaJ-00011U-5N
	for submit <at> debbugs.gnu.org; Thu, 21 Feb 2013 19:33:55 -0500
Received: from eggs.gnu.org ([208.118.235.92]:42988)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <rrt@HIDDEN>) id 1U8gaG-0005UK-A2
	for bug-gnu-emacs@HIDDEN; Thu, 21 Feb 2013 19:33:55 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <rrt@HIDDEN>) id 1U8ga7-0000yY-NJ
	for bug-gnu-emacs@HIDDEN; Thu, 21 Feb 2013 19:33:51 -0500
Received: from exprod7og109.obsmtp.com ([64.18.2.171]:39801)
	by eggs.gnu.org with smtp (Exim 4.71) (envelope-from <rrt@HIDDEN>)
	id 1U8ga7-0000xB-Az
	for bug-gnu-emacs@HIDDEN; Thu, 21 Feb 2013 19:33:43 -0500
Received: from mail-la0-f71.google.com ([209.85.215.71]) (using TLSv1) by
	exprod7ob109.postini.com ([64.18.6.12]) with SMTP
	ID DSNKUSa825E409PvJvLsZcluMd2oB9/FWP8U@HIDDEN;
	Thu, 21 Feb 2013 16:33:43 PST
Received: by mail-la0-f71.google.com with SMTP id fr10so163753lab.2
	for <bug-gnu-emacs@HIDDEN>; Thu, 21 Feb 2013 16:33:31 -0800 (PST)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
	d=google.com; s=20120113;
	h=x-received:x-received:from:to:subject:date:message-id:mime-version
	:content-type:x-gm-message-state;
	bh=b6qcDr19tbG7x/QCsQKSyTDotmKmwadhMWzJQUFHGCE=;
	b=miz5WLK5nqOS7MKwlu/5DiCXnZjn1k8BKKj7SytSv6cgQPcnzGwaep60deyfdLgs6R
	5G1+uCVCTPpcj/yVHWA5exPsdQMIy6NQKi/FwayklPrn6S0XziS2lL1PVXdFykzmSPGf
	PW+ZFVERLPmor1hNg6H2TrgQ+okFcEdfTDaRt30wgCN5hn////GoN/4WL2cad2pdctFL
	izLTAOmYfmfXeYb4My44G2vroU40iLpA/YN6V4hdFFJ4W20EZ4PVcPyBo2O5fgaPnB3Z
	4H/41Bq7RKAAfQJVQFoGLIrLGsAWN6D47UEKBopBfoDdCnia0i4Jf5xsDz2mD5gCgvya
	vdDw==
X-Received: by 10.180.100.169 with SMTP id ez9mr46017566wib.3.1361493211158;
	Thu, 21 Feb 2013 16:33:31 -0800 (PST)
X-Received: by 10.180.100.169 with SMTP id ez9mr46017555wib.3.1361493211017;
	Thu, 21 Feb 2013 16:33:31 -0800 (PST)
Received: from skwd ([149.241.115.91])
	by mx.google.com with ESMTPS id ay10sm1373173wib.3.2013.02.21.16.33.30
	(version=TLSv1 cipher=ECDHE-RSA-RC4-SHA bits=128/128);
	Thu, 21 Feb 2013 16:33:30 -0800 (PST)
From: Reuben Thomas <rrt@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 24.2; Making find-file-hook customizable seems to cause troublle
Date: Fri, 22 Feb 2013 00:33:29 +0000
Message-ID: <87k3q1gpba.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Gm-Message-State: ALoCoQketYdUz7ZVhjl1rtsnj6SDr+ta1LP+pLi0qpELtsZo1pvxPu1yHiDZl0YAMmAwwS/0Fg1SWymWVEjqZSGBTvVMXcaeM71H6ZDOI7p8PdB/OZnDpOJ+OzNvbTRrjjf9PVTmgA37XBW9vHAkJdQnaoPO7lhiRXvkL8+PGY2a5ctGwBSFORY=
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.4.x
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 208.118.235.17
X-Spam-Score: -6.2 (------)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.2 (------)

I just spent a while trying to work out why a third-party mode I had
just installed was not automatically added to my find-file-hook, even
though the mode's file calls add-hook when it is loaded, and I took care
to ensure the mode was autoloaded. I discovered that the problem was
that the mode was loaded by my customization file, custom.el, but later,
the same file overwrote find-file-hook, because I had customized
find-file-hook.

I found that the reason for the customization was to get flymake-mode
automatically activated; I've filed a separate issue about this
(#13779). After removing the customization, my find-file-hook was set up
correctly (except for flymake-mode).

The real problem here is that find-file-hook is clearly meant to be
customizable (there is even a check box for auto-indent in its
customization dialog), yet customizing it seems to cause a race
condition where depending in what order files are autoloaded, hooks may
fail to be added properly to find-file-hook.

For the moment, I have added an add-hook call to my Emacs init file to
set up flymake-mode, and removed the customization, but it would be nice
if customizing the hook were both possible (perhaps by ensuring that
customized hooks were added to rather than overwritten?) and safe.


In GNU Emacs 24.2.1 (x86_64-pc-linux-gnu, GTK+ Version 2.24.13)
 of 2012-12-13 on komainu, modified by Debian
Windowing system distributor `The X.Org Foundation', version 11.0.11300000
Configured using:
 `configure '--build' 'x86_64-linux-gnu' '--build' 'x86_64-linux-gnu'
 '--prefix=/usr' '--sharedstatedir=/var/lib' '--libexecdir=/usr/lib'
 '--localstatedir=/var/lib' '--infodir=/usr/share/info'
 '--mandir=/usr/share/man' '--with-pop=yes'
 '--enable-locallisppath=/etc/emacs24:/etc/emacs:/usr/local/share/emacs/24.2/site-lisp:/usr/local/share/emacs/site-lisp:/usr/share/emacs/24.2/site-lisp:/usr/share/emacs/site-lisp'
 '--with-crt-dir=/usr/lib/x86_64-linux-gnu' '--with-x=yes'
 '--with-x-toolkit=gtk' '--with-toolkit-scroll-bars'
 'build_alias=x86_64-linux-gnu' 'CFLAGS=-g -O2 -fstack-protector
 --param=ssp-buffer-size=4 -Wformat -Werror=format-security -Wall'
 'CPPFLAGS=-D_FORTIFY_SOURCE=2''

Important settings:
  value of $LC_ALL: nil
  value of $LC_COLLATE: nil
  value of $LC_CTYPE: nil
  value of $LC_MESSAGES: nil
  value of $LC_MONETARY: en_GB.UTF-8
  value of $LC_NUMERIC: en_GB.UTF-8
  value of $LC_TIME: en_GB.UTF-8
  value of $LANG: en_GB.UTF-8
  value of $XMODIFIERS: nil
  locale-coding-system: utf-8-unix
  default enable-multibyte-characters: t

Major mode: Emacs-Lisp

Minor modes in effect:
  diff-auto-refine-mode: t
  recentf-mode: t
  show-paren-mode: t
  server-mode: t
  savehist-mode: t
  minibuffer-electric-default-mode: t
  iswitchb-mode: t
  icomplete-mode: t
  global-auto-revert-mode: t
  dtrt-indent-mode: t
  desktop-save-mode: t
  TeX-PDF-mode: t
  TeX-source-correlate-mode: t
  tooltip-mode: t
  mouse-wheel-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  column-number-mode: t
  line-number-mode: t
  transient-mark-mode: t

Recent input:
SPC i t SPC s h o u l d SPC b e SPC r e m o v e d SPC 
, SPC a n d <backspace> <backspace> <backspace> <backspace> 
<backspace> , <backspace> <backspace> , SPC a n d SPC 
a SPC m o r e SPC s t a <backspace> <backspace> <backspace> 
u s e r - f r i e n d l y SPC a n d SPC s t a n d a 
r d SPC w a y SPC o f SPC a c t i v a t i n g SPC f 
l y m a k e - m o d e SPC g l o b v a <backspace> <backspace> 
<backspace> a <backspace> b a l l y SPC <M-backspace> 
a u t o m a t i c a l l y SPC a d d e d ? M-q C-c C-c 
y e s <return> C-x k <return> C-x k <return> C-x k 
<return> C-x k <return> C-x k <return> C-a C-SPC C-n 
M-w C-x k <return> C-a C-x k <return> y e s <return> 
C-x b v a r s C-g C-x C-f v a <tab> <return> C-n C-n 
C-n C-n C-n C-n C-n C-n C-n C-n C-n C-n C-n C-n C-n 
C-n C-n C-n C-n C-n C-n C-n C-n C-n C-n C-n C-n C-n 
C-n C-n C-n C-n C-n C-n C-n C-n C-p C-p C-p C-p C-p 
C-p C-p C-p C-p C-y C-p C-d C-d C-d C-d C-d C-d C-d 
C-d C-d C-x C-s C-n C-n C-n C-n C-n C-n C-n C-n C-n 
C-n C-n C-n C-n C-n C-n C-n C-n C-n C-n C-n C-n C-n 
C-n C-n M-x r e p o r t - e m a c s - b u g <retur
n>

Recent messages:
Sending...
Sending via mail...
Sending...done
Mark set
Quit
byte-code: End of buffer [16 times]
Mark set
Saving file /home/rrt/.emacs.d/vars.el...
Wrote /home/rrt/.emacs.d/vars.el
byte-code: End of buffer [13 times]
byte-code: End of buffer

Load-path shadows:
/home/rrt/local/share/emacs/site-lisp/browse-kill-ring hides /usr/share/emacs24/site-lisp/emacs-goodies-el/browse-kill-ring
/home/rrt/local/share/emacs/site-lisp/dict hides /usr/share/emacs24/site-lisp/emacs-goodies-el/dict
/home/rrt/.emacs.d/elpa/dictionary-1.8.7/dictionary-init hides /usr/share/emacs24/site-lisp/dictionary-el/dictionary-init
/home/rrt/.emacs.d/elpa/dictionary-1.8.7/dictionary hides /usr/share/emacs24/site-lisp/dictionary-el/dictionary
/home/rrt/.emacs.d/elpa/dictionary-1.8.7/link hides /usr/share/emacs24/site-lisp/dictionary-el/link
/home/rrt/.emacs.d/elpa/dictionary-1.8.7/connection hides /usr/share/emacs24/site-lisp/dictionary-el/connection
/usr/share/emacs24/site-lisp/auctex/tex-style hides /usr/share/emacs/site-lisp/auctex/tex-style
/usr/share/emacs24/site-lisp/auctex/tex-mik hides /usr/share/emacs/site-lisp/auctex/tex-mik
/usr/share/emacs24/site-lisp/auctex/multi-prompt hides /usr/share/emacs/site-lisp/auctex/multi-prompt
/usr/share/emacs24/site-lisp/auctex/tex-jp hides /usr/share/emacs/site-lisp/auctex/tex-jp
/usr/share/emacs24/site-lisp/auctex/tex-info hides /usr/share/emacs/site-lisp/auctex/tex-info
/usr/share/emacs24/site-lisp/auctex/plain-tex hides /usr/share/emacs/site-lisp/auctex/plain-tex
/usr/share/emacs24/site-lisp/auctex/latex hides /usr/share/emacs/site-lisp/auctex/latex
/usr/share/emacs24/site-lisp/auctex/preview hides /usr/share/emacs/site-lisp/auctex/preview
/usr/share/emacs24/site-lisp/auctex/tex hides /usr/share/emacs/site-lisp/auctex/tex
/usr/share/emacs24/site-lisp/auctex/texmathp hides /usr/share/emacs/site-lisp/auctex/texmathp
/usr/share/emacs24/site-lisp/auctex/context-nl hides /usr/share/emacs/site-lisp/auctex/context-nl
/usr/share/emacs24/site-lisp/auctex/tex-font hides /usr/share/emacs/site-lisp/auctex/tex-font
/usr/share/emacs24/site-lisp/auctex/toolbar-x hides /usr/share/emacs/site-lisp/auctex/toolbar-x
/usr/share/emacs24/site-lisp/auctex/tex-buf hides /usr/share/emacs/site-lisp/auctex/tex-buf
/usr/share/emacs24/site-lisp/auctex/bib-cite hides /usr/share/emacs/site-lisp/auctex/bib-cite
/usr/share/emacs24/site-lisp/auctex/context-en hides /usr/share/emacs/site-lisp/auctex/context-en
/usr/share/emacs24/site-lisp/auctex/tex-fold hides /usr/share/emacs/site-lisp/auctex/tex-fold
/usr/share/emacs24/site-lisp/auctex/tex-bar hides /usr/share/emacs/site-lisp/auctex/tex-bar
/usr/share/emacs24/site-lisp/auctex/context hides /usr/share/emacs/site-lisp/auctex/context
/usr/share/emacs24/site-lisp/auctex/prv-emacs hides /usr/share/emacs/site-lisp/auctex/prv-emacs
/usr/share/emacs24/site-lisp/auctex/font-latex hides /usr/share/emacs/site-lisp/auctex/font-latex
/usr/share/emacs/site-lisp/golang-mode/go-mode-load hides /usr/share/emacs/24.2/site-lisp/golang-mode/go-mode-load
/usr/share/emacs/site-lisp/golang-mode/go-mode hides /usr/share/emacs/24.2/site-lisp/golang-mode/go-mode
/usr/share/emacs/24.2/site-lisp/cmake-data/cmake-mode hides /usr/share/emacs/site-lisp/cmake-mode
/usr/share/emacs/24.2/site-lisp/cdargs hides /usr/share/emacs/site-lisp/cdargs
/usr/share/emacs/site-lisp/rst hides /usr/share/emacs/24.2/lisp/textmodes/rst
/usr/share/emacs24/site-lisp/dictionaries-common/ispell hides /usr/share/emacs/24.2/lisp/textmodes/ispell
/usr/share/emacs24/site-lisp/dictionaries-common/flyspell hides /usr/share/emacs/24.2/lisp/textmodes/flyspell

Features:
(time-stamp cus-edit info mule-util shadow sort mail-extr emacsbug
message format-spec rfc822 mml mml-sec mm-decode mm-bodies mm-encode
mail-parse rfc2231 mailabbrev gmm-utils mailheader sendmail rfc2047
rfc2045 ietf-drums mail-utils add-log log-view pcvs-util vc-annotate vc
ediff-merg ediff-diff ediff-wind ediff-help ediff-util ediff-mult
ediff-init ediff vc-dispatcher vc-bzr find-func etags latexenc preview
prv-emacs tex-buf font-latex latex tex-style misearch multi-isearch
m4-mode conf-mode newcomment make-mode pp help-mode view lua-mode
nroff-mode autoconf autoconf-mode sh-script executable todoo noutline
outline flymake compile comint ansi-color ring inform-mode diff-git
diff-mode vc-git cc-mode cc-fonts cc-guess cc-menus cc-cmds cc-styles
cc-align cc-engine cc-vars cc-defs jka-compr face-remap flyspell ispell
smart-quotes auto-dictionary-autoloads c-eldoc-autoloads
dictionary-autoloads diff-git-autoloads dired-isearch-autoloads
full-ack-autoloads guess-style-autoloads kill-ring-search-autoloads
magit-autoloads mv-shell-autoloads tumble-autoloads
http-post-simple-autoloads package tabulated-list completing-help
recentf tree-widget wid-edit uniquify paren server savehist
minibuf-eldef iswitchb icomplete autorevert dtrt-indent desktop
cus-start cus-load ropemacs pymacs warnings url-util url-parse
auth-source eieio byte-opt bytecomp byte-compile cconv macroexp
gnus-util password-cache url-vars mm-util mail-prsvr tex dbus xml
regexp-opt remember user-site-loaddefs advice advice-preload yasnippet
help-fns derived edmacro kmacro easymenu assoc cl muse-autoloads
go-mode-load emacs-goodies-el emacs-goodies-custom
emacs-goodies-loaddefs easy-mmode preview-latex tex-site auto-loads
time-date tooltip ediff-hook vc-hooks lisp-float-type mwheel x-win x-dnd
tool-bar dnd fontset image fringe lisp-mode register page menu-bar
rfn-eshadow timer select scroll-bar mouse jit-lock font-lock syntax
facemenu font-core frame cham georgian utf-8-lang misc-lang vietnamese
tibetan thai tai-viet lao korean japanese hebrew greek romanian slovak
czech european ethiopic indian cyrillic chinese case-table epa-hook
jka-cmpr-hook help simple abbrev minibuffer loaddefs button faces
cus-face files text-properties overlay sha1 md5 base64 format env
code-pages mule custom widget hashtable-print-readable backquote
make-network-process dbusbind dynamic-setting system-font-setting
font-render-setting move-toolbar gtk x-toolkit x multi-tty emacs)

-- 
http://rrt.sc3d.org/




Acknowledgement sent to Reuben Thomas <rrt@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#13780; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Fri, 31 Oct 2014 17:00:04 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.